# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "tb2-BME280"

"""    import                                                 """
from   machine import Pin,I2C
import time
import sensors.bme280

from lib.config import Config
_config = Config()

""" init                                                       """
print('this is program: ', progname)

if _config.get_value('sensors','bme280', 'enabled'):
    try:
        i2c = I2C(0, I2C.MASTER, pins=(
            _config.get_value('sensors','bme280', 'pin_sda'),
            _config.get_value('sensors','bme280', 'pin_scl')))
        bme280 = sensors.bme280.BME280(address=0x77, i2c=i2c)
        print("BME280: initialization OK. ")
    except:
        bme280 = None
        print("BME280: initialization failed. Is it connected properly?")
else:
    bme280 = None

""" Messen                                                     """
# Read data from BME280
if bme280 is not None:
    try:
        bme280val = bme280.read_compensated_data()      # read BME280
        bme280tmp = round(bme280val[0],2)            # 2 decimal places
        bme280pre = round(bme280val[1]/100,1)
        bme280hum = round(bme280val[2],2)
        print('BME280:', bme280tmp, 'C', bme280pre, 'mbar', bme280hum, '%')
    except:
        print("BME280 not measuring.")
