# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "tb4-BME280"

"""    import                                                 """
from   machine import Pin,I2C
import time
import sensors.bme280

from lib.config import Config
config = Config()

""" init                                                                     """
print('this is program: ', progname)

if config.get_value('sensors','bme280', 'enabled'):
    try:
        i2c = I2C(0, I2C.MASTER, pins=(
            config.get_value('sensors','bme280', 'pin_sda'),
            config.get_value('sensors','bme280', 'pin_scl')))
        bme280 = sensors.bme280.BME280(address=0x77, i2c=i2c)
        print("BME280: initialization OK. ")
    except:
        bme280 = None
        print("BME280: initialization failed. Is it connected properly?")
else:
    bme280 = None

""" Messen                                                                   """
countanf =  1
countmax = 10
for count in range(countanf, countmax+1):
    print("{:2d}/{:2d} ".format(count, countmax), end='')
    # Read data from BME280
    if bme280 is not None:
        try:
            bme280val = bme280.read_compensated_data()      # read BME280
            # bme280tmp = round(bme280val[0],2)               # 2 decimal places
            # bme280pre = round(bme280val[1]/100,1)
            # bme280hum = round(bme280val[2],2)
            bme280tmp = "{:4.1f}".format(bme280val[0])
            bme280pre = "{:6.1f}".format(bme280val[1]/100)
            bme280hum = "{:4.1f}".format(bme280val[2])
            print('BME280:', bme280tmp, 'C', bme280pre, 'mbar', bme280hum, '%')
        except:
            print("BME280 not measuring.")
