# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "tc1-SSD1306"

"""    import                                                 """
from   machine import Pin, I2C, ADC
import utime
import sensors.ssd1306

from lib.config import Config
_config = Config()

adc = ADC(0)


""" init                                                       """
print('this is program: ', progname)

if _config.get_value('general','general', 'oled'):
    try:
        i2c = I2C(0, I2C.MASTER, pins=(
            _config.get_value('sensors','bme280', 'pin_sda'),
            _config.get_value('sensors','bme280', 'pin_scl')))
        oled = sensors.ssd1306.SSD1306_I2C(128, 64, i2c)    # OLED x, y, bus
        oled.contrast(250)
        print("OLED: initialization OK. ")
    except:
        oled = None
        print("OLED: initialization failed. Is it connected properly?")
else:
    oled = None

""" Messen                                                     """
if oled is not None:
    try:
        print('OLED: Text')
        oled.fill(0)                                       # alles aus
        oled.text("1234567890123456", 0,  0)               # Textausgabe
        oled.text("Zeile2          ", 0,  8)
        oled.show()                                         # anzeigen
        time.sleep(1)

    except:
        print("OLED not working.")

""" Messen                                                     """
countanf =   1
countmax =  20
for count in range(countanf, countmax+1):
    print("{:3d}/{:3d} ".format(count, countmax), end='  ')

    adw = adc.channel(pin='P16',attn=ADC.ATTN_11DB)  #  max. 3.7 V
    wert = adw()
    print('VBATT:', wert, end=' ')
    ist  = 2640  # Wert des ADW
    soll = 4440  # Sollausgabe in mV
    volt = wert * (soll / ist)
    volt = round(volt/1000,2)
    print('Volt:', volt, 'V' )

#    print('OLED: Text')
    oled.fill(0)                                       # alles aus
    oled.text("Wert    Spannung", 0,   0)               # Textausgabe
    oled.text(str(count),         0,  10)
    oled.text(str(wert),          0,  20)
    oled.text(str(volt),         65,  20)
    oled.text("V",              105,  20)

    oled.show()

    utime.sleep(1)
