# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "te1-DS18B20"

"""    import                                                 """
from   machine import Pin, I2C
import time
import binascii
#import sensors.hx711

from lib.onewire     import OneWire
from sensors.ds18x20 import DS18X20

from config import Config
_config = Config()

""" init                                                       """
owPin   = 'P11'
ow      = OneWire(Pin(owPin))
ds18b20 = DS18X20(ow)
roms    = ds18b20.scan()
print(roms)
if not roms:
    print("No DS18B20 found. Is it connected properly?")
else:
    print("Found ", len(roms), "DS18B20")
    ds18b20.convert_temp()
    time.sleep_ms(750)


""" Messen                                                     """
print('this is program: ', progname)

roms = ds18b20.scan()
if roms:
    ds18b20.convert_temp()
    time.sleep_ms(750)
    print('DS18B20: Measurement started ...')
else:
    print("No DS18B20 found. Is it connected properly?")

print('DS18B20:', end=' ')
for rom in roms:
    print(ds18b20.read_temp(rom), end=" ")
print()

print('Ausgabe mit ID')
dsnr = 0
for rom in roms:
    dsnr += 1
    name = binascii.hexlify(rom).decode('utf-8')
    tmp  = ds18b20.read_temp(rom)
    if tmp is not None:
        ds18b20tmp = round(tmp, 1)
    else:
        ds18b20tmp =  9999
    print('DS18B20:', dsnr, name, ds18b20tmp, 'C')

print('Test auf CRC-Error')
dsnr = 0
for rom in roms:
    dsnr += 1
    name = binascii.hexlify(rom).decode('utf-8')
    try:
        tmp  = ds18b20.read_temp(rom)       # Sensor read
        ds18b20tmp = round(tmp, 1)
    except:                                 # CRC-Error
        ds18b20tmp =  9999
    print('DS18B20:', dsnr, name, ds18b20tmp, 'C')

#
