# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "te4-DS18B20"

"""    import                                                 """
from   machine import Pin, I2C
import time
import binascii

from lib.onewire     import OneWire
from sensors.ds18x20 import DS18X20

from config import Config
config = Config()

""" init                                                       """
print('this is program: ', progname)
if config.get_value('sensors', 'ds18b20', 'enabled'):
    owPin  = config.get_value('sensors', 'ds18b20', 'pin')
    ow     = OneWire(Pin(owPin))
    ds18b20 = DS18X20(ow)
    roms    = ds18b20.scan()
    if not roms:
        print("No DS18B20 found. Is it connected properly?")
    else:
        print("Found ", len(roms), "DS18B20")
        ds18b20.convert_temp()
        # time.sleep_ms(750)
else:
    ds18b20 = None


""" Messen                                                     """
print('this is program: ', progname)

if ds18b20 is not None:
    roms = ds18b20.scan()
    if roms:
        ds18b20.convert_temp()
        time.sleep_ms(750)
        print('DS18B20: Measurement started ...')
    else:
        print("No DS18B20 found. Is it connected properly?")

    print('Test auf CRC-Error')
    dsnr = 0
    for rom in roms:
        dsnr += 1
        name = binascii.hexlify(rom).decode('utf-8')
        try:
            tmp  = ds18b20.read_temp(rom)       # Sensor read
            ds18b20tmp = round(tmp, 1)
        except:                                 # CRC-Error
            ds18b20tmp =  9999
        print('DS18B20:', dsnr, name, ds18b20tmp, 'C')

####
ds_positions = {v: k for k, v in
             config.get_value('sensors', 'ds18b20', 'positions').items()}
print('ds_positions',ds_positions)

for pos in ds_positions:
    print('pos:', pos, ds_positions[pos])

print(ds_positions['28ffbfc931180173'])


if ds18b20 is not None:
    print('   DS18B20:', end=' ')
    ds_data   = ds18b20.read_all(ds_positions)
    ds_len    = len(ds_data)
    ds_lenmax = len(config.get_value('sensors', 'ds18b20', 'positions'))
    if ds_len < ds_lenmax:
        print('   only', ds_len, 'of', ds_lenmax, 'DS18B20 available')
    print('ds_data',ds_data)





#
