# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "te5-DS18B20"

"""    import                                                 """
from   machine import Pin, I2C
import time
import binascii
import sys
import json

from lib.onewire     import OneWire
from sensors.ds18x20 import DS18X20

from config import Config
config = Config()

""" init                                                       """
print('this is program: ', progname)
if config.get_value('sensors', 'ds18b20', 'enabled'):
    owPin  = config.get_value('sensors', 'ds18b20', 'pin')
    ow     = OneWire(Pin(owPin))
    ds18b20 = DS18X20(ow)
    roms    = ds18b20.scan()
    if not roms:
        print("No DS18B20 found. Is it connected properly?")
    else:
        print("Found ", len(roms), "DS18B20")
        ds18b20.convert_temp()
        # time.sleep_ms(750)
else:
    ds18b20 = None


""" Messen                                                     """
print('this is program: ', progname)

if ds18b20 is not None:
    roms = ds18b20.scan()
    if roms:
        ds18b20.convert_temp()
        time.sleep_ms(750)
        print('DS18B20: Measurement started ...')
    else:
        print("No DS18B20 found. Is it connected properly?")

    print('Messen mit Test auf CRC-Error')
    dsnr = 0
    for rom in roms:
        dsnr += 1
        name = binascii.hexlify(rom).decode('utf-8')
        try:
            tmp  = ds18b20.read_temp(rom)       # Sensor read
            ds18b20tmp = round(tmp, 1)
        except:                                 # CRC-Error
            ds18b20tmp =  9999
        print('DS18B20:', dsnr, name, ds18b20tmp, 'C')

print(' ')
print('1... ')
ds_positions = {v: k for k, v in
             config.get_value('sensors', 'ds18b20', 'positions').items()}
print('ds_positions:',ds_positions)
for pos in ds_positions:
    print('pos:', pos, ds_positions[pos])

ds_korrektur = {v: k for k, v in
             config.get_value('sensors', 'ds18x20', 'korrektur').items()}
print('ds_korrektur:',ds_korrektur)
for pos in ds_korrektur:
    print('pos:', pos, ds_korrektur[pos])

test1 = config.get_value('sensors', 'ds18x20', 'korrektur')
print('test1:', test1)
#print('t_i_1:', test1["t_i_1"])
korr1 = test1["t_i_1"]; print('korr1:', korr1 )
korr2 = test1["t_i_2"]; print('korr2:', korr2 )
korr3 = test1["t_i_3"]; print('korr3:', korr3 )
korr4 = test1["t_i_4"]; print('korr4:', korr4 )
korr5 = test1["t_i_5"]; print('korr5:', korr5 )
korr6 = test1["t_o"  ]; print('korr6:', korr6 )

#x =  '{ "name":"John", "age":30, "city":"New York", "t_o": "6666" }'
#print(x)
#y = json.loads(x)
#print(y)
#print(y["age"])
"""
test2 =  '{"t_i_1": "1111", "t_i_2": "2222", "t_i_3": "3333", "t_i_4": "4444", "t_i_5": "5555", "t_o": "6666"}'
print('test2:', test2)
print('0:', test2[0])
print('1:', test2[1])

test3 = json.loads(test2)
print('test3:', test3)
print('t_i_1:', test3["t_i_1"])
print('t_i_2:', test3["t_i_2"])
"""
#sys.exit()
# print(ds_positions['28ffbfc931180173'])
print(' ')
print('2... ')
if ds18b20 is not None:
    print('DS18B20:', end=' ')
    ds_data   = ds18b20.read_all(ds_positions)
    ds_len    = len(ds_data)
    ds_lenmax = len(config.get_value('sensors', 'ds18b20', 'positions'))
    if ds_len < ds_lenmax:
        print('   only', ds_len, 'of', ds_lenmax, 'DS18B20 available')
    print('ds_data:',ds_data)

print(' ')
print('3... ')

if ds18b20 is not None:
    ds_positions = {v: k for k, v in
             config.get_value('sensors', 'ds18b20', 'positions').items()}
    print('ds_positions:',ds_positions)

    ds_korrektur = config.get_value('sensors', 'ds18x20', 'korrektur')
    print('ds_korrektur:', ds_korrektur)


    roms = ds18b20.scan()
    if roms:
        ds18b20.convert_temp()
        time.sleep_ms(750)
        print('DS18B20: Measurement started ...')
    else:
        print("No DS18B20 found. Is it connected properly?")

    # print('Messen mit Test auf CRC-Error')
    dsnr = 0
    data = {}
    for rom in roms:
        dsnr += 1
        name = binascii.hexlify(rom).decode('utf-8')
        try:
            tmp  = ds18b20.read_temp(rom)       # Sensor read
            ds18b20tmp = round(tmp, 1)
        except:                                 # CRC-Error
            print("CRC-Err", end = ' ')
            ds18b20tmp =  9999
            continue
        print('DS18B20:', dsnr, name, ds18b20tmp, end=' ')
        ds_key = ds_positions[name]
    #   print(ds_key, end=' ')
        ds_korr = ds_korrektur[ds_key]
        print(ds_korr, end=' ' )
        ds18b20korr = ds18b20tmp  + float(ds_korr)
        print(ds18b20korr, end=' ')
        print(ds_key)


        #
