# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "te6-DS18B20"

"""    import                                                 """
from   machine import Pin, I2C
import time
import binascii
import sys
import json

from lib.onewire     import OneWire
from sensors.ds18x20 import DS18X20

from config import Config
config = Config()

""" init                                                       """
print('this is program: ', progname)
if config.get_value('sensors', 'ds18b20', 'enabled'):
    owPin  = config.get_value('sensors', 'ds18b20', 'pin')
    ow     = OneWire(Pin(owPin))
    ds18b20 = DS18X20(ow)
    ds_roms    = ds18b20.scan()
    if not ds_roms:
        print("No DS18B20 found. Is it connected properly?")
    else:
        print("Found ", len(ds_roms), "DS18B20")
        ds18b20.convert_temp()
        # time.sleep_ms(750)
else:
    ds18b20 = None

ds_positions = {v: k for k, v in
     config.get_value('sensors', 'ds18b20', 'positions').items()}
print('ds_positions:',ds_positions)




""" Messen                                                     """
print('this is program: ', progname)

if ds18b20 is not None:
    ds_roms = ds18b20.scan()
    if ds_roms:
        ds18b20.convert_temp()
        time.sleep_ms(750)
        print('DS18B20: Measurement started ...')
    else:
        print("No DS18B20 found. Is it connected properly?")

    print('Messen mit Test auf CRC-Error')
    print('DS18B20:', end=' ')
    ds_data   = ds18b20.read_all(ds_positions)
    ds_len    = len(ds_data)
    ds_lenmax = len(config.get_value('sensors', 'ds18b20', 'positions'))
    if ds_len < ds_lenmax:
        print('   only', ds_len, 'of', ds_lenmax, 'DS18B20 available')
    print('ds_data:',ds_data)

print(' ')
print('3... ')

if ds18b20 is not None:
    ds_positions = {v: k for k, v in
             config.get_value('sensors', 'ds18b20', 'positions').items()}
    print('ds_positions:',ds_positions)

    ds_korrektur = config.get_value('sensors', 'ds18x20', 'korrektur')
    print('ds_korrektur:', ds_korrektur)

    #Starten
    ds_roms = ds18b20.scan()
    if ds_roms:
        ds18b20.convert_temp()
        time.sleep_ms(750)
        print('DS18B20: Measurement started ...')
    else:
        print("No DS18B20 found. Is it connected properly?")

    # Messen mit Test auf CRC-Error
    ds_num = 0
    data = {}
    for ds_rom in ds_roms:
        ds_num += 1
        ds_name = binascii.hexlify(ds_rom).decode('utf-8')
        try:
            tmp  = ds18b20.read_temp(ds_rom)       # Sensor read
            ds_temp = tmp
        except:                                 # CRC-Error
            print("CRC-Err", end = ' ')
            ds_temp =  9999
            continue
        ds_key  = ds_positions[ds_name]
        ds_korr = ds_korrektur[ds_key]
        ds_tmpk = ds_temp  + float(ds_korr)
        if ds_name in ds_positions:
            data[ds_positions[ds_name]] = ds_tmpk
        print('DS18B20:', ds_num, ds_name, ds_temp, ds_korr, ds_tmpk, ds_key, data )
        # print(ds_tmpk, end=' ')
    print(' Sensors:', len(ds_roms) )

print(' ')
print('4... ')
if ds18b20 is not None:
    ds_positions = config.get_value('sensors', 'ds18b20', 'positions')
    print('ds_positions:',ds_positions)
    ds_positions = {v: k for k, v in
             config.get_value('sensors', 'ds18b20', 'positions').items()}
    print('ds_positions:',ds_positions)
    ds_korrektur = config.get_value('sensors', 'ds18x20', 'korrektur')
    print('ds_korrektur:', ds_korrektur)
    #Starten
    ds18b20.start()
    print('DS18B20: ', end='')
    ds_data = ds18b20.read_korr(ds_positions, ds_korrektur)
    print('ds_data:', ds_data)



        #
