# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "te7-DS18B20"

"""    import                                                 """
from   machine import Pin, I2C
import time
import binascii
import sys
import json

from lib.onewire     import OneWire
from sensors.ds18x20 import DS18X20

from config import Config
config = Config()

""" init                                                       """
print('this is program: ', progname)
if config.get_value('sensors', 'ds18b20', 'enabled'):
    owPin  = config.get_value('sensors', 'ds18b20', 'pin')
    ow     = OneWire(Pin(owPin))
    ds18b20 = DS18X20(ow)
    ds_roms    = ds18b20.scan()
    if not ds_roms:
        print("No DS18B20 found. Is it connected properly?")
    else:
        print("Found ", len(ds_roms), "DS18B20")
        ds18b20.convert_temp()
        # time.sleep_ms(750)
else:
    ds18b20 = None

ds_positions = {v: k for k, v in
     config.get_value('sensors', 'ds18b20', 'positions').items()}
print('ds_positions:',ds_positions)
ds_korrektur = config.get_value('sensors', 'ds18x20', 'korrektur')
print('ds_korrektur:', ds_korrektur)

""" Messen                                                     """
print(' ')
print('4... ')
if ds18b20 is not None:
    #Starten
    ds18b20.start()
    print('DS18B20: ', end='')
    ds_data = ds18b20.read_korr(ds_positions, ds_korrektur)
    print('ds_data:', ds_data)

print(' ')
print('5. Mittelwert ')
if ds18b20 is not None:
    ds18b20.start()

    ds_roms = ds18b20.roms
    ds_num  = 0
    ds_mitt = 0
    data = {}
    for ds_rom in ds_roms:
        ds_num += 1
        ds_name = binascii.hexlify(ds_rom).decode('utf-8')
        try:
            tmp  =  ds18b20.read_temp(ds_rom)       # Sensor read
            ds_temp = tmp
        except:                                 # CRC-Error
            print("CRC-Err", end = ' ')
            ds_temp =  9999
            continue
        ds_key  = ds_positions[ds_name]
        ds_korr = ds_korrektur[ds_key]
        ds_tmpk = ds_temp  + float(ds_korr)
        ds_tmpk = "{:5.2f}".format(ds_tmpk)
        ds_len  = len(ds_roms)
        if ds_name in ds_positions:
            data[ds_positions[ds_name]] = ds_tmpk
        ds_mitt = ds_mitt + ds_temp
        ### print('DS18B20:', ds_num, ds_name, ds_temp, ds_korr, ds_tmpk, ds_key, data )
        print(ds_temp, ds_tmpk, end=',  ')
    print(' Sensors:', ds_len, end='  ' )
    ds_mitt = ds_mitt / ds_len
    print(' mittel:', ds_mitt  )

print(' ')
print('6. Korrektur')
print(' mittel:', ds_mitt  )
if ds18b20 is not None:
    ds18b20.start()

    ds_roms = ds18b20.roms
    ds_num  = 0
    korr = {}
    data = {}
    for ds_rom in ds_roms:
        ds_num += 1
        ds_name = binascii.hexlify(ds_rom).decode('utf-8')
        try:
            tmp  =  ds18b20.read_temp(ds_rom)       # Sensor read
            ds_temp = tmp
        except:                                 # CRC-Error
            print("CRC-Err", end = ' ')
            ds_temp =  9999
            continue
        ds_key  = ds_positions[ds_name]
        ds_korr = ds_korrektur[ds_key]
        ds_korr = ds_mitt - ds_temp

        korr[ds_num] = ds_korr


        ds_tmpk = ds_temp  + float(ds_korr)
        ds_tmpk = "{:5.2f}".format(ds_tmpk)
#        ds_len  = len(ds_roms)
        print('DS18B20:', ds_num, ds_name, ds_temp, ds_korr, ds_tmpk, ds_key )

    print('ds_korrektur:', ds_korrektur)
    print('korrektur   :', korr[1], korr[2], korr[3], korr[4], korr[5], korr[6] )
    ds_key  = 't_i_1';     ds_korrektur[ds_key] = korr[1]
    ds_key  = 't_i_2';     ds_korrektur[ds_key] = korr[2]
    ds_key  = 't_i_3';     ds_korrektur[ds_key] = korr[3]
    ds_key  = 't_i_4';     ds_korrektur[ds_key] = korr[4]
    ds_key  = 't_i_5';     ds_korrektur[ds_key] = korr[5]
    ds_key  = 't_o';       ds_korrektur[ds_key] = korr[6]
    print('ds_korrektur:', ds_korrektur)

    config.write(0)

ds_key  = 't_i_1'
ds_korrektur = config.get_value_detail('sensors', 'ds18x20', 'korrektur', ds_key )
print('kontrolle   :  ', ds_key, ':', ds_korrektur, end=' ')

ds_key  = 't_i_2'
ds_korrektur = config.get_value_detail('sensors', 'ds18x20', 'korrektur', ds_key )
print(' ', ds_key, ':', ds_korrektur, end=' ')

ds_key  = 't_i_3'
ds_korrektur = config.get_value_detail('sensors', 'ds18x20', 'korrektur', ds_key )
print(' ', ds_key, ':', ds_korrektur, end=' ')
ds_key  = 't_i_4'
ds_korrektur = config.get_value_detail('sensors', 'ds18x20', 'korrektur', ds_key )
print(' ', ds_key, ':', ds_korrektur, end=' ')
ds_key  = 't_i_5'
ds_korrektur = config.get_value_detail('sensors', 'ds18x20', 'korrektur', ds_key )
print(' ', ds_key, ':', ds_korrektur, end=' ')
ds_key  = 't_o'
ds_korrektur = config.get_value_detail('sensors', 'ds18x20', 'korrektur', ds_key )
print(' ', ds_key, ':', ds_korrektur, end=' ')
print('')

# funktioniert nicht
#config.set_value_detail('sensors', 'ds18x20', 'korrektur', 't_i_1', ds_korrektur)
