# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "te8-DS18B20"

"""    import                                                 """
from   machine import Pin, I2C
import time
import binascii
import sys
import json

from lib.onewire     import OneWire
from sensors.ds18x20 import DS18X20

from config import Config
config = Config()

""" init                                                       """
print('this is program: ', progname)
if config.get_value('sensors', 'ds18b20', 'enabled'):
    owPin  = config.get_value('sensors', 'ds18b20', 'pin')
    ow     = OneWire(Pin(owPin))
    ds18b20 = DS18X20(ow)
    ds_roms    = ds18b20.scan()
    if not ds_roms:
        print("No DS18B20 found. Is it connected properly?")
    else:
        print("Found ", len(ds_roms), "DS18B20")
        ds18b20.convert_temp()
        # time.sleep_ms(750)
else:
    ds18b20 = None

ds_positions = {v: k for k, v in
     config.get_value('sensors', 'ds18b20', 'positions').items()}
# print('ds_positions:',ds_positions)
ds_korrektur = config.get_value('sensors', 'ds18x20', 'korrektur')
# print('ds_korrektur:', ds_korrektur)

""" Messen                                                     """
print(' ')
print('7. Messen ohne Korrektur')
if ds18b20 is not None:
    ds18b20.start()
    print('DS18B20: ', end='')
    ds_data   = ds18b20.read_all(ds_positions)

print('8. Messen mit Korrektur')
if ds18b20 is not None:
    ds18b20.start()
    print('DS18B20: ', end='')
    ds_data = ds18b20.read_korr(ds_positions, ds_korrektur)

print(' ')
countanf =  1
countmax = 10
for count in range(countanf, countmax+1):
    print("{:2d}/{:2d} ".format(count, countmax), end='')
    if ds18b20 is not None:
        ds18b20.start()
        print('DS18B20     : ', end='')
        ds_data   = ds18b20.read_all(ds_positions)
        ds18b20.start()
        print('      ', end='')
        print('DS18B20 korr: ', end='')
        ds_data = ds18b20.read_korr(ds_positions, ds_korrektur)
