# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "tg1-log-BME280"

"""    import                                                 """
from   machine import Pin,I2C

import   time
rtc    = machine.RTC()
import   sensors.timing
timing = sensors.timing.TIMING()

from lib.config import Config
config = Config()

import logger
csv  = logger.csv

import network
import uos

from lib.wlanmanager import WLanManager
config  = Config.getInstance()
wlanman = WLanManager(config)
wlan    = network.WLAN(id=0)

import sensors.bme280

""" init                                                       """
print('this is program: ', progname)

print("WLan       : is enabled, trying to connect.")
wlanman.enable_client()
IPadr, Netmask, Gateway, DNS = wlan.ifconfig()
print('Wlan IP-Adr:', IPadr)
print('Wlan SSID  :', wlan.ssid())
print('Wlan host  :', wlan.hostname())

print('             Set NTP -> RTC')
Date, Time = timing.RTCget()
print('RTC alt    :', Date, Time, rtc.now())
rtcdatetime = timing.RTCsetNTP()
print('RTC NTP    : Set from NTP to UTC', rtcdatetime )
Date, Time = timing.RTCget()
print('RTC UTC    :', Date, Time, rtc.now())
Date, Time = timing.GetCEST()
print('RTC CEST   :', Date, Time)

if config.get_value('sensors','bme280', 'enabled'):
    try:
        i2c = I2C(0, I2C.MASTER, pins=(
            config.get_value('sensors','bme280', 'pin_sda'),
            config.get_value('sensors','bme280', 'pin_scl')))
        bme280 = sensors.bme280.BME280(address=0x77, i2c=i2c)
        print("BME280   : initialization OK. ")
    except:
        bme280 = None
        print("BME280: initialization failed. Is it connected properly?")
else:
    bme280 = None

""" Messen                                                     """
countanf =  1
countmax =  2 # 10
for count in range(countanf, countmax+1):
    print("{:2d}/{:2d} ".format(count, countmax), end='')
    data = {}

    """  Read data from BME280  """
    if bme280 is not None:
        try:
            bme280val = bme280.read_compensated_data()      # read BME280
            bme280tmp = round(bme280val[0],2)               # 2 decimal places
            bme280pre = round(bme280val[1]/100,1)
            bme280hum = round(bme280val[2],2)
            print('BME280   :', bme280tmp, 'C', bme280pre, 'mbar', bme280hum, '%')
            data['t'] = bme280tmp
            data['p'] = bme280pre
            data['h'] = bme280hum
        except:
            print("BME280 not measuring.")

        """ Date and Time """
        Date, Time = timing.GetCEST()
        print('      RTC CEST :', Date, Time)
        """ Data on SD-Card """
        print('      Data     :', data)
        if csv is not None:
            csv.add_data_bob(data, config.get_value('general', 'general', 'plt'), count)
