# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "tg4-log"

"""    import                                                 """
import machine
from   machine import Pin, I2C, RTC
import binascii

import   utime
rtc    = machine.RTC()
import   sensors.timing
timing = sensors.timing.TIMING()

i2c    = I2C(0, I2C.MASTER, pins=('P9', 'P10'))
ds     = sensors.ds3231.DS3231(i2c)


from lib.config import Config

import logger
csv  = logger.csv
beep = logger.beep

import network
import uos

from lib.wlanmanager import WLanManager
config  = Config.getInstance()
wlanman = WLanManager(config)
wlan    = network.WLAN(id=0)

import sensors.bme280
import sensors.hx711
from   lib.onewire     import OneWire
from   sensors.ds18x20 import DS18X20
import sensors.ssd1306


""" defines                                                    """
Uaus0 = 4.2
Uaus1 = 4.2
IntervalAlarmAus  =  30           # aus   sec  1. Test 1 Messung pro 1 Minute
IntervalAlarmEin  =  20           # ein

def DS3231Show():
    Date = "{:04d}-{:02d}-{:02d}".format(*ds.getDate())
    Time = "{:02d}:{:02d}:{:02d}".format(*ds.getTime())
    print( Date, Time, end=' ')
    Status = ds.ReadStatus()
    if Status == 0:
        print(' Alarm     aus', end=' ')
    if Status == 1:
        print(' Alarm  1  ein', end=' ')
    if Status == 2:
        print(' Alarm  2  ein', end=' ')
    if Status == 3:
        print(' Alarm 1+2 ein', end=' ')
    if Status == 4:
        print(' Alarm BSY aus', end=' ')
    if Status == 5:
        print(' Alarm BSY ein', end=' ')


""" init                                                       """
print('this is program: ', progname)

print("WLan       : is enabled, trying to connect.")
wlanman.enable_client()
IPadr, Netmask, Gateway, DNS = wlan.ifconfig()
print('Wlan IP-Adr:', IPadr)
print('Wlan SSID  :', wlan.ssid())
print('Wlan host  :', wlan.hostname())

print('             Set NTP -> RTC')
Date, Time = timing.RTCget()
print('RTC alt    :', Date, Time, rtc.now())
rtcdatetime = timing.RTCsetNTP()
print('RTC NTP    : Set from NTP to UTC', rtcdatetime )
Date, Time = timing.RTCget()
print('RTC UTC    :', Date, Time, rtc.now())
Date, Time = timing.GetCEST()
print('RTC CEST   :', Date, Time)

print(' ')
print('             Set RTC -> DS3231')
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 alt :', Date, Time, alarm, alarmstatus)
#print('Status', ds.ReadStatus())

YYYY, MM, DD, hh, mm, ss = timing.DS3231setCEST()
print('DS3231     : from RTC to CEST                  ', YYYY, MM, DD, hh, mm, ss )
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 neu :', Date, Time, alarm, alarmstatus)
#print('Status', ds.ReadStatus())

# Setzen von Alarm 1
(year, month,  day)                     = ds.getDate()
(hour, minute, second)                  = ds.getTime()
timeakt = utime.mktime([year,month,day,hour,minute,second, 0, 0])
timealarm = timeakt  + 1 # IntervalAlarmAus
(year, month,  day, hour, minute, second, x1, x2) =  utime.gmtime(timealarm)
Date = "{:4d}-{:02d}-{:02d}".format(*ds.getDate())
Time = "{:02d}:{:02d}:{:02d}".format(hour, minute, second)
# print(' ->', Time, end='')
ds.setAlarm1(day, hour, minute, second, sensors.ds3231.A1_ON_HOUR_MINUTE_SECOND)
ds.enableAlarm1()
ds.resetAlarm1()

Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 alar:', Date, Time, alarm, alarmstatus)
print('Status', ds.ReadStatus())
utime.sleep(1)
print('Status', ds.ReadStatus())


print('')
""" Messen                                                     """
countanf =   1
countmax = 10
for count in range(countanf, countmax+1):
    print("{:3d}/{:3d} ".format(count, countmax), end='  ')

    """ Date and Time """
    Date, Time = timing.GetCEST()
#    print('       RTC CEST :', Date, Time)
#    print('  ')

    # Bestimmen der Schaltzeiten
    if Uaus0 < 4.0: IntervalAlarmAus =   30   # + 30 sec =  1 min     60 / Stunde
    if Uaus0 < 3.8: IntervalAlarmAus =   90   # + 30 sec =  2 min     30 / Stunde
    if Uaus0 < 3.6: IntervalAlarmAus =  270   # + 30 sec =  5 min     12 / Stunde
    if Uaus0 < 3.4: IntervalAlarmAus =  570   # + 30 sec = 10 min      6 / Stunde
    if Uaus0 < 3.2: IntervalAlarmAus = 1770   # + 30 sec = 30 min      2 / Stunde
    if Uaus0 < 3.0: IntervalAlarmAus = 3570   # + 30 sec = 60 min      1 / Stunde
    IntervalAlarmAus =   5 # + 1 # 3+1
    IntervalAlarmEin =   5 # - 2 # 3-2
    IntervalAlarmAus = IntervalAlarmAus + 1
    IntervalAlarmEin = IntervalAlarmEin - 2

#    print('             ', end='')
#    print('Uaus0:', Uaus0, '-> IntervalAlarmAus:', IntervalAlarmAus, end='')
#    print(' IntervalAlarmEin:', IntervalAlarmEin)

#    print('             DS3231   : ', end='')
    DS3231Show()
    # Status akt. Zeit
    (year, month,  day)                     = ds.getDate()
    (hour, minute, second)                  = ds.getTime()
    timeakt = utime.mktime([year,month,day,hour,minute,second, 0, 0])
    # Status Alarm 1
    (day, hour, minute, second, x1, x2, x3) = ds.getAlarm1State()
    Time = "{:02d}:{:02d}:{:02d}".format(hour, minute, second)
    print(' ->', Time, end='')
    timealarm = utime.mktime([year,month,day,hour,minute,second, 0, 0])
    # neue Alarmzeit berechnen und setzen
    if timeakt > timealarm + IntervalAlarmEin:
#        print(' ')
#        print('                                         neu ', end='')
        print('  neu ', end='')
        timealarm = timeakt + IntervalAlarmAus
        (year, month,  day, hour, minute, second, x1, x2) =  utime.gmtime(timealarm)
        Date = "{:4d}-{:02d}-{:02d}".format(*ds.getDate())
        Time = "{:02d}:{:02d}:{:02d}".format(hour, minute, second)
        print(' ->', Time, end='')
        ds.setAlarm1(day, hour, minute, second, sensors.ds3231.A1_ON_HOUR_MINUTE_SECOND)
        ds.enableAlarm1()
        ds.resetAlarm1()










    wait = 1
    print(' ')
#    print('            ', wait, 'sec warten ...')
    utime.sleep(wait)

    cycle = count
    timesleep = 10
    Date, Time = timing.GetCEST()
#        if cycle == 1:
#            print('end of cycle', cycle, ': sleep', timesleep, 'sec at', Time)
#            time.sleep(timesleep)
    if cycle == 200:
        print('end of cycle', cycle, ': deepsleep', timesleep, 'sec at', Time)
        machine.deepsleep(timesleep*1000)
