# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "tg7-log"
host     = 'WiPy2'

"""    import                                                 """
import machine
from   machine import Pin, I2C, RTC, ADC
import binascii

import   utime
rtc    = machine.RTC()
import   sensors.timing
timing = sensors.timing.TIMING()
i2c    = I2C(0, I2C.MASTER, pins=('P9', 'P10'))
ds     = sensors.ds3231.DS3231(i2c)

from lib.config import Config

import logger
csv  = logger.csv
beep = logger.beep

import network
import uos

from lib.wlanmanager import WLanManager
config  = Config.getInstance()
wlanman = WLanManager(config)
wlan    = network.WLAN(id=0)

import sensors.bme280
import sensors.hx711
from   lib.onewire     import OneWire
from   sensors.ds18x20 import DS18X20
import sensors.ssd1306

adc = ADC(0)

""" defines                                                    """
Uaus0 = 4.2
Uaus1 = 4.2
IntervalAlarmAus  =  30           # aus   sec  1. Test 1 Messung pro 1 Minute

def DS3231Show():
    Date = "{:04d}-{:02d}-{:02d}".format(*ds.getDate())
    Time = "{:02d}:{:02d}:{:02d}".format(*ds.getTime())
    print( Date, Time, end=' ')
    Status = ds.ReadStatus()
    if Status == 0:
        print(' Alarm     aus', end=' ')
    if Status == 1:
        print(' Alarm  1  ein', end=' ')
    if Status == 2:
        print(' Alarm  2  ein', end=' ')
    if Status == 3:
        print(' Alarm 1+2 ein', end=' ')
    if Status == 4:
        print(' Alarm BSY aus', end=' ')
    if Status == 5:
        print(' Alarm BSY ein', end=' ')

""" init                                                       """
print('this is program: ', progname)

print("WLan       : is enabled, trying to connect.")
wlanman.enable_client()
IPadr, Netmask, Gateway, DNS = wlan.ifconfig()
print('Wlan IP-Adr:', IPadr)
print('Wlan SSID  :', wlan.ssid())
wlan.hostname(host)
print('Wlan host  :', wlan.hostname())

print('             Set NTP -> RTC')
Date, Time = timing.RTCget()
print('RTC alt    :', Date, Time, rtc.now())
rtcdatetime = timing.RTCsetNTP()
print('RTC NTP    : Set from NTP to UTC', rtcdatetime )
Date, Time = timing.RTCget()
print('RTC UTC    :', Date, Time, rtc.now())
Date, Time = timing.GetCEST()
print('RTC CEST   :', Date, Time)





if config.get_value('sensors','bme280', 'enabled'):
    try:
        i2c = I2C(0, I2C.MASTER, pins=(
            config.get_value('sensors','bme280', 'pin_sda'),
            config.get_value('sensors','bme280', 'pin_scl')))
        bme280 = sensors.bme280.BME280(address=0x77, i2c=i2c)
        print("BME280     : initialization OK. ")
    except:
        bme280 = None
        print("BME280: initialization failed. Is it connected properly?")
else:
    bme280 = None

if config.get_value('sensors', 'hx711', 'enabled'):
    hx711 = sensors.hx711.HX711(
        config.get_value('sensors', 'hx711', 'pin_dout'),
        config.get_value('sensors', 'hx711', 'pin_pdsck'))
    hx711.set_scale( config.get_value('sensors', 'hx711', 'calibration_factor'))
    hx711.set_offset(config.get_value('sensors', 'hx711', 'tare_offset'))
    print("HX711      : initialization OK. ")
else:
    hx711 = None
    print("HX711: initialization failed. ")

if config.get_value('sensors', 'ds18b20', 'enabled'):
    owPin  = config.get_value('sensors', 'ds18b20', 'pin')
    ow     = OneWire(Pin(owPin))
    ds18b20 = DS18X20(ow)
    roms    = ds18b20.scan()
    if not roms:
        print("No DS18B20 found. Is it connected properly?")
    else:
        print("DS18B20    : ", len(roms), "found")
        ds18b20.convert_temp()
        # time.sleep_ms(750)
        ds_positions = {v: k for k, v in
             config.get_value('sensors', 'ds18b20', 'positions').items()}
        #print(ds_positions)
else:
    ds18b20 = None

if config.get_value('general','general', 'oled'):
    try:
        i2c = I2C(0, I2C.MASTER, pins=(
            config.get_value('sensors','bme280', 'pin_sda'),
            config.get_value('sensors','bme280', 'pin_scl')))
        oled = sensors.ssd1306.SSD1306_I2C(128, 64, i2c)    # OLED x, y, bus
        oled.contrast(250)
        print("OLED       : initialization OK. ")
    except:
        oled = None
        print("OLED : initialization failed. Is it connected properly?")
else:
    oled = None

""" Compare RTC and DS3231 """
"""
# RTC
Date, Time = timing.GetCEST()
print('RTC CEST   :', Date, Time)
now = utime.time()
timeRTC = now + 3600
print('RTC    sec :', timeRTC)
# DS3231
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231     :', Date, Time, alarm, alarmstatus)
(year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
print('DS3231 sec :', timeDS3231)
timedif = timeDS3231 - timeRTC
print('Diff   sec :', timedif)
"""
####
# YYYY, MM, DD, hh, mm, ss = timing.DS3231setCEST()
# print('DS3231     : from RTC to CEST                  ', YYYY, MM, DD, hh, mm, ss )
# print('DS3231 neu :', Date, Time, alarm, alarmstatus)
# dd, hh, mm, ss, type, enabled, triggerd = alarmstatus
# print('Status     : day:', dd, 'hour:', hh, 'min:', mm, 'sec:', ss, 'type:', type, 'enabled:', enabled, 'triggerd:', triggerd)
####

""" Compare RTC and DS3231 """
# RTC
Date, Time = timing.GetCEST()
print('RTC CEST   :', Date, Time, end=' ')
now = utime.time()
timeRTC = now + 3600
print(' sec :', timeRTC)
# DS3231
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
# print('DS3231     :', Date, Time, alarm, alarmstatus)
(year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
print('DS3231     :', Date, Time, ' sec :', timeDS3231,  alarm, alarmstatus)
#print('DS3231 sec :', timeDS3231)
timedif = timeDS3231 - timeRTC
print('Diff   sec :', timedif)

print('')
""" Messen                                                     """
countanf =   1
countmax =  20
for count in range(countanf, countmax+1):
    print("{:3d}/{:3d} ".format(count, countmax), end='  ')
    data = {}

    """ Status von DS3231 """
    # DS3231Show()
    Date, Time, alarm, alarmstatus = timing.DS3231getfull()
    print('DS3231 akt :', Date, Time, alarm, alarmstatus)

    """ Messen """
    """  Read data from BME280  """
    if bme280 is not None:
        try:
            bme280val = bme280.read_compensated_data()      # read BME280
            bme280tmp = round(bme280val[0],2)               # 2 decimal places
            bme280pre = round(bme280val[1]/100,1)
            bme280hum = round(bme280val[2],2)
            print('      BME280   :', bme280tmp, 'C', bme280pre, 'mbar', bme280hum, '%')
            data['t'] = bme280tmp
            data['p'] = bme280pre
            data['h'] = bme280hum
        except:
            print("BME280 not measuring.")

    """ Read data from HX711 Gewicht """
    if hx711 is not None:
        hx711akt = hx711.get_value(times=5)
        hx711akt = round(hx711akt, 2)       # 3 decimal places
        print('      HX711    : ', hx711akt, 'g' )
        data['weight_kg'] = hx711akt

    """ Read data from DS18B20 Temperaturen """
    if ds18b20 is not None:
        roms = ds18b20.scan()
        if roms:
            ds18b20.convert_temp()
            utime.sleep_ms(750)
###         print('   DS18B20: Measurement started ...')
        else:
            print("No DS18B20 found. Is it connected properly?")
        #print('       ', end='')
        print('      DS18B20  :', end=' ')
        ds_data   = ds18b20.read_all(ds_positions)
        data.update(ds_data)

    """ Read data from ADC  Voltage  """
    adw = adc.channel(pin='P16',attn=ADC.ATTN_11DB)  #  max. 3.7 V
    wert = adw()
    print('      VBATT    : Value:', wert, end=' ')
    # Wert des ADW
    vist  = config.get_value('general','general', 'vist')
    # Sollausgabe in mV
    vsoll = config.get_value('general','general', 'vsoll')
    volt = wert * (vsoll / vist)
    volt = round(volt/1000,2)
    print('   Volt:', volt, 'V' )
    data['bv'] = volt





    """ Ausgaben """
    """ Date and Time """
    Date, Time = timing.GetCEST()
    print('      RTC CEST :', Date, Time)
    """ Data on SD-Card """
    print('      Data     :', data)
    if csv is not None:
        csv.add_data_bob(data, config.get_value('general', 'general', 'plt'), count)

    print('      ', end='')
    if beep is not None:
        beep.add(data)

    """ Ausgabe auf OLED """
    if oled is not None:
        try:
            print('      OLED     : Ausgabe')
            oled.fill(0)                                       # alles aus
            oled.text(str(count),                   0,  0)
            oled.text(Time,                        64,  0)
            oled.text("Waage           "   ,        0,  9)
            if 'weight_kg' in data:
                oled.text(str(data['weight_kg']),  64,  9)
                oled.text("kg",                   112,  9)
                oled.text("   C    hPa    %"   ,        0, 18)
                if 't' in data:
                    oled.text(str(round(data['t'],1)),   0, 27)
                if 'p' in data:
                    oled.text(str(round(data['p'],1)),  40, 27)
                if 'h' in data:
                    oled.text(str(round(data['h'],1)),  95, 27)
                oled.text("DS18B20         "   ,         0, 36)
                oled.text(str(volt),                   85,  36)
                oled.text("V",                        118,  36)
                if 't_i_1' in data:
                    oled.text(str(data['t_i_1'])    ,   0, 45)
                if 't_i_2' in data:
                    oled.text(str(data['t_i_2'])    ,  50, 45)
                if 't_i_3' in data:
                    oled.text(str(data['t_i_3'])    ,  95, 45)
                if 't_i_4' in data:
                    oled.text(str(data['t_i_4'])    ,   0, 54)
                if 't_i_5' in data:
                    oled.text(str(data['t_i_5'])    ,  50, 54)
                if 't_o' in data:
                    oled.text(str(data['t_o'])      ,  95, 54)
            oled.show()

        except:
            print('OLED defect',end=' ')

    """  Bestimmen der Schaltzeiten  """
    if Uaus0 < 4.0: IntervalAlarmAus =   30   # + 30 sec =  1 min     60 / Stunde
    if Uaus0 < 3.8: IntervalAlarmAus =   90   # + 30 sec =  2 min     30 / Stunde
    if Uaus0 < 3.6: IntervalAlarmAus =  270   # + 30 sec =  5 min     12 / Stunde
    if Uaus0 < 3.4: IntervalAlarmAus =  570   # + 30 sec = 10 min      6 / Stunde
    if Uaus0 < 3.2: IntervalAlarmAus = 1770   # + 30 sec = 30 min      2 / Stunde
    if Uaus0 < 3.0: IntervalAlarmAus = 3570   # + 30 sec = 60 min      1 / Stunde
    #IntervalAlarmAus =   10
### print('Uaus0:', Uaus0, '-> IntervalAlarmAus:', IntervalAlarmAus)
    IntervalAlarmAus = IntervalAlarmAus + 1

    """ Alarm neu berechnen """
    if count == 2:
        # Status akt. Zeit
        (year, month,  day)                     = ds.getDate()
        (hour, minute, second)                  = ds.getTime()
        timeakt = utime.mktime([year,month,day,hour,minute,second, 0, 0])
        timealarm = timeakt + IntervalAlarmAus
        print('             ', end='')
#        print('timeakt:', timeakt, 'timealarm:', timealarm, end='')
        (year, month,  day, hour, minute, second, x1, x2) =  utime.gmtime(timealarm)
        Date = "{:4d}-{:02d}-{:02d}".format(*ds.getDate())
        Time = "{:02d}:{:02d}:{:02d}".format(hour, minute, second)
        print('Alarm neu  in', IntervalAlarmAus, 'sec um', Date, Time)
        ds.setAlarm1(day, hour, minute, second, sensors.ds3231.A1_ON_HOUR_MINUTE_SECOND)
        ds.enableAlarm1()
        Date, Time, alarm, alarmstatus = timing.DS3231getfull()
        (year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
        timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
        print('2 DS3231     :', Date, Time, ' sec :', timeDS3231,  alarm, alarmstatus)

        # Testausgaben am Ende
        utime.sleep(2)
        oled.fill(0)                                       # alles aus
        oled.text(str(count),                   0,  0)
        oled.text(Time,                        64,  0)
#        oled.show()
        oled.text("Spannung",                   0,  36)
        oled.text(str(volt),                   85,  36)
        oled.text("V",                        118,  36)
#        oled.text("               x"   ,         0, 45)
        oled.text("DS3231"             ,         0, 45)
        oled.text( Time ,                       60, 45)

#        oled.text("               x"   ,         0, 54)
        oled.text("Interval"            ,         0, 54)
        oled.text(str(IntervalAlarmAus),        100, 54)

        oled.show()
    ###    ds.resetAlarm1()
        Date, Time, alarm, alarmstatus = timing.DS3231getfull()
        (year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
        timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
        print('3 DS3231     :', Date, Time, ' sec :', timeDS3231,  alarm, alarmstatus)

        YYYY, MM, DD, hh, mm, ss = timing.DS3231setCEST()
        print('DS3231     : from RTC to CEST                  ', YYYY, MM, DD, hh, mm, ss )
        # print('DS3231 neu :', Date, Time, alarm, alarmstatus)
        # dd, hh, mm, ss, type, enabled, triggerd = alarmstatus
        # print('Status     : day:', dd, 'hour:', hh, 'min:', mm, 'sec:', ss, 'type:', type, 'enabled:', enabled, 'triggerd:', triggerd)

        """ Compare RTC and DS3231 """
        # RTC
        Date, Time = timing.GetCEST()
        print('RTC CEST   :', Date, Time, end=' ')
        now = utime.time()
        timeRTC = now + 3600
        print(' sec :', timeRTC)
        # DS3231
        Date, Time, alarm, alarmstatus = timing.DS3231getfull()
        (year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
        timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
        print('DS3231     :', Date, Time, ' sec :', timeDS3231,  alarm, alarmstatus)
        timedif = timeDS3231 - timeRTC
        print('Diff   sec :', timedif)


        cycle = count
        timesleep = IntervalAlarmAus
        Date, Time = timing.GetCEST()
        print('end of cycle', cycle, ': deepsleep', timesleep, 'sec at', Date, Time)
        # utime.sleep(timesleep)
        machine.deepsleep(timesleep*1000)

    wait = 1
    utime.sleep(wait)
