# Testprogramm für Platine BOB-HAT-V2    Didi Lamken 4.7.2020
progname = "th1-DS3231"

"""   python imports                                           """
from machine import Pin, I2C
import sensors.ds3231
from machine import RTC
import time

""" init                                                       """
i2c    = I2C(0, I2C.MASTER, pins=('P9', 'P10'))
ds     = sensors.ds3231.DS3231(i2c)
rtc    = RTC()

""" defines                                                    """
def DS3231ShowTime(countmax):
    for count in range(countmax):
        Date = "{:04d}-{:02d}-{:02d}".format(*ds.getDate())
        Time = "{:02d}:{:02d}:{:02d}".format(*ds.getTime())
        print('{:2d}.'.format(count+1), end=' ')
        print('DS3231:', Date, end=' ')
        print( Time, end=' ')
        Control = ds.ReadControl()
        print(' Control:', Control, end=' ' )
        Status = ds.ReadStatus()
        print(' Status:',  Status, end=' ')
        if Status == 0:
            print(' Alarm     aus', end=' ')
        if Status == 1:
            print(' Alarm  1  ein', end=' ')
        if Status == 2:
            print(' Alarm  2  ein', end=' ')
        if Status == 3:
            print(' Alarm 1+2 ein', end=' ')
        print(' ')
        time.sleep(1)

def RtcShowTime(countmax):
    for count in range(countmax):
        rtcdatetime = rtc.now()
        Date = "{:04d}-{:02d}-{:02d}".format(*rtcdatetime[0:3])
        Time = "{:02d}:{:02d}:{:02d}".format(*rtcdatetime[3:6])
        print('{:2d}.'.format(count+1), end=' ')
        print('RTC:   ', Date, end=' ')
        print(Time)
        time.sleep(1)

def DS3231ShowByte(countanf, countmax):
    for count in range(countanf,countmax+1):
        addr = count
        wert = ds.GetByte(addr)
        print('count: {:2d}.'.format(count), end='  ')
        print('addr: {:02X}h'.format(addr),  end='  ')
        print(' Wert:  {:03d}d  {:02X}h  {:08b} b '.format(wert, wert, wert))

def setRTCLocalTime():
    rtc = RTC()
    rtc.ntp_sync("pool.ntp.org")
    utime.sleep_ms(750)
    print('\nRTC Set from NTP to UTC:       ', rtc.now())
    utime.timezone(-18000)
    print('Adjusted from UTC to EST timezone', utime.localtime(), '\n')

""" Messen                                                    """
print('hier ist Programm ', progname)

print('    Auslesen der RTC DS3231')
# Temperatur
print('Temperatur:', ds.getTemperature())
# Uhrzeit
DS3231ShowTime(2)
# Uhrzeit RTC
RtcShowTime(2)

print('Auslesen von Bytes')
DS3231ShowByte(14, 15)
