# Testprogramm für Platine BOB-Strom-V2    Didi Lamken 15.11.2020
progname = "td4-Time-Test4"

"""   python imports                                           """
from machine import Pin, I2C, RTC
import sensors.ds3231
import sensors.timing

import time
import utime

""" init                                                       """
i2c    = I2C(0, I2C.MASTER, pins=('P9', 'P10'))
ds     = sensors.ds3231.DS3231(i2c)
rtc    = RTC()
timing = sensors.timing.TIMING()

""" defines                                                    """

def DS3231ShowTime(countmax):
    for count in range(countmax):
        Date = "{:04d}-{:02d}-{:02d}".format(*ds.getDate())
        Time = "{:02d}:{:02d}:{:02d}".format(*ds.getTime())
        print('{:2d}.'.format(count+1), end=' ')
        print('DS3231 :', Date, Time, end=' ')
        Control = ds.ReadControl()
        #print('Control:', Control, end=' ' )
        Status = ds.ReadStatus()
        #print('    Status:', Status, end='    ')
        if Status == 0:
            alarm = 'Alarm     aus'
        if Status == 1:
            alarm = 'Alarm  1  ein'
        if Status == 2:
            alarm = 'Alarm  2  ein'
        if Status == 3:
            alarm = 'Alarm 1+2 ein'
        if Status == 4:
            alarm = 'Alarm Stat 4 '
        if Status == 5:
            alarm = 'Alarm Stat 5 '
        print(alarm, end=' ')
        print(' Control:', Control, end=' ' )
        print('    Status:', Status)
        time.sleep(1)



""" Messen                                                    """
print('hier ist Programm ', progname)

print('             Set NTP -> RTC')
Date, Time = timing.RTCget()
print('RTC alt    :', Date, Time, rtc.now())
rtcdatetime = timing.RTCsetNTP()
print('RTC NTP    : Set from NTP to UTC', rtcdatetime )
Date, Time = timing.RTCget()
print('RTC UTC    :', Date, Time, rtc.now())

rtc.init(rtc.now())
print('             time.localtime:    ', time.localtime())
now=time.time()
print('             time.time:         ', time.time())

cet=time.localtime(now+3600)
rtcdatetime = cet
Date = "{:04d}-{:02d}-{:02d}".format(*rtcdatetime[0:3])
Time = "{:02d}:{:02d}:{:02d}".format(*rtcdatetime[3:6])
print('RTC CET    :', Date, Time, cet)


Date, Time = timing.GetCET()
print('RTC CET    :', Date, Time)
Date, Time = timing.GetCEST()
print('RTC CEST   :', Date, Time)
year, month, day, hour, minute, second, ms, dayinyear = timing.GetTime()
print('             GetTime             ',year, month, day, hour, minute, second, ms, dayinyear)


print(' ')
print('             Set RTC -> DS3231')
Date, Time = timing.DS3231get()
print('DS3231 alt :', Date, Time)
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 alt :', Date, Time, alarm, alarmstatus)
YYYY, MM, DD, hh, mm, ss = timing.DS3231setCEST()
print('DS3231     : from RTC to CEST                  ', YYYY, MM, DD, hh, mm, ss )
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 neu :', Date, Time, alarm, alarmstatus)

print(' ')
print('             Set DS3231 -> Alarm 1 Version 1')
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 alt :', Date, Time, alarm, alarmstatus)
interval = 2
Date, Time = timing.DS3231setAlarm1a(interval)    # Version 1
print('Alarm 1     ', Date, Time, 'Alarmzeit neu  in', interval, 'sec')
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 neu :', Date, Time, alarm, alarmstatus)
DS3231ShowTime(4)
Alarm1State = timing.DS3231resetAlarm1()
print('                                 Alarm  1  aus', Alarm1State)
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 neu :', Date, Time, alarm, alarmstatus)
DS3231ShowTime(2)

print(' ')
print('             Set DS3231 -> Alarm 1 Version 2')
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 alt :', Date, Time, alarm, alarmstatus)
interval = 2
Date, Time = timing.DS3231setAlarm1(interval)    # Version 2
print('Alarm 1     ', Date, Time, 'Alarmzeit neu  in', interval, 'sec')
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 neu :', Date, Time, alarm, alarmstatus)
DS3231ShowTime(4)
Alarm1State = timing.DS3231resetAlarm1()
print('                                 Alarm  1  aus', Alarm1State)
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 neu :', Date, Time, alarm, alarmstatus)
DS3231ShowTime(2)

print(' ')
print('             DS3231 -> Status')
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 akt :', Date, Time, alarm, alarmstatus)
dd, hh, mm, ss, type, enabled, triggerd = alarmstatus
print('Status       day:', dd, 'hour:', hh, 'min:', mm, 'sec:', ss, 'type:', type, 'enabled:', enabled, 'triggerd:', triggerd)

#
