# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.1.2021
progname = "tg6-log"
host     = 'WiPy2'

"""    import                                                 """
import machine
from   machine import Pin, I2C, RTC
import binascii

import   utime
rtc    = machine.RTC()
import   sensors.timing
timing = sensors.timing.TIMING()
i2c    = I2C(0, I2C.MASTER, pins=('P9', 'P10'))
ds     = sensors.ds3231.DS3231(i2c)

from lib.config import Config

import logger
csv  = logger.csv
beep = logger.beep

import network
import uos

from lib.wlanmanager import WLanManager
config  = Config.getInstance()
wlanman = WLanManager(config)
wlan    = network.WLAN(id=0)

import sensors.bme280
import sensors.hx711
from   lib.onewire     import OneWire
from   sensors.ds18x20 import DS18X20
import sensors.ssd1306

""" defines                                                    """
Uaus0 = 4.2
Uaus1 = 4.2
IntervalAlarmAus  =  30           # aus   sec  1. Test 1 Messung pro 1 Minute



""" init                                                       """
print('this is program: ', progname)


if config.get_value('sensors', 'hx711', 'enabled'):
    hx711 = sensors.hx711.HX711(
        config.get_value('sensors', 'hx711', 'pin_dout'),
        config.get_value('sensors', 'hx711', 'pin_pdsck'))
    hx711.set_scale( config.get_value('sensors', 'hx711', 'calibration_factor'))
    hx711.set_offset(config.get_value('sensors', 'hx711', 'tare_offset'))
    print("HX711      : initialization OK. ")
else:
    hx711 = None
    print("HX711: initialization failed. ")

# print('1', config.get_value('sensors', 'hx711', 'enabled')   )
# print('2', config.get_value('sensors', 'hx711', 'pin_dout')   )
# print('3', config.get_value('sensors', 'hx711', 'pin_pdsck')   )
# print('4', config.get_value('sensors', 'hx711', 'calibration_factor')   )
print('5   ', config.get_value('sensors', 'hx711', 'tare_offset')   )

tare = config.get_value('sensors', 'hx711', 'tare_offset')
print('tare', tare)
tare = -102802
print('tare', tare)
config.set_value('sensors', 'hx711', 'tare_offset', tare)
tare = config.get_value('sensors', 'hx711', 'tare_offset')
print('tare', tare)
config.write()


if config.get_value('sensors', 'ds18b20', 'enabled'):
    owPin  = config.get_value('sensors', 'ds18b20', 'pin')
    ow     = OneWire(Pin(owPin))
    ds18b20 = DS18X20(ow)
    roms    = ds18b20.scan()
    if not roms:
        print("No DS18B20 found. Is it connected properly?")
    else:
        print("DS18B20    : ", len(roms), "found")
        ds18b20.convert_temp()
        # time.sleep_ms(750)
        ds_positions = {v: k for k, v in
             config.get_value('sensors', 'ds18b20', 'positions').items()}
        # print(ds_positions)
else:
    ds18b20 = None
"""
print('1', config.get_value('sensors', 'ds18b20', 'enabled')   )
print('2', config.get_value('sensors', 'ds18b20', 'pin')   )
print('3', config.get_value('sensors', 'ds18b20', 'positions')   )
print('4', config.get_value('sensors', 'ds18b20', 'positions').items()  )
"""

print('')
""" Messen                                                     """
countanf =   1
countmax =   2
for count in range(countanf, countmax+1):
    print("{:3d}/{:3d} ".format(count, countmax), end='  ')
    data = {}


    """ Messen """


    if ds18b20 is not None:
        roms = ds18b20.scan()
        if roms:
            ds18b20.convert_temp()
            utime.sleep_ms(750)
###         print('   DS18B20: Measurement started ...')
        else:
            print("No DS18B20 found. Is it connected properly?")
        #print('       ', end='')
        print('      DS18B20  :', end=' ')
        ds_data   = ds18b20.read_all(ds_positions)
        data.update(ds_data)




    wait = 1
    utime.sleep(wait)
