# Testprogramm für Platine BOB-Strom-V2    Didi Lamken 15.11.2020
progname = "th3-DS3231-Test3"
host     = 'WiPy2'

"""   python imports                                           """

import machine
from   machine import Pin, I2C, RTC
import binascii

import   utime
rtc    = machine.RTC()
import   sensors.timing
timing = sensors.timing.TIMING()
i2c    = I2C(0, I2C.MASTER, pins=('P9', 'P10'))
ds     = sensors.ds3231.DS3231(i2c)

from lib.config import Config

#import logger
#csv  = logger.csv
#beep = logger.beep

import network
import uos

from lib.wlanmanager import WLanManager
config  = Config.getInstance()
wlanman = WLanManager(config)
wlan    = network.WLAN(id=0)




""" init                                                       """


print("WLan       : is enabled, trying to connect.")
wlanman.enable_client()
IPadr, Netmask, Gateway, DNS = wlan.ifconfig()
print('Wlan IP-Adr:', IPadr)
print('Wlan SSID  :', wlan.ssid())
wlan.hostname(host)
print('Wlan host  :', wlan.hostname())


#i2c    = I2C(0, I2C.MASTER, pins=('P9', 'P10'))
#ds     = sensors.ds3231.DS3231(i2c)
#rtc    = RTC()
#timing = sensors.timing.TIMING()

""" defines                                                    """

def DS3231ShowTime(countmax):
    for count in range(countmax):
        Date = "{:04d}-{:02d}-{:02d}".format(*ds.getDate())
        Time = "{:02d}:{:02d}:{:02d}".format(*ds.getTime())
        print('{:2d}.'.format(count+1), end=' ')
        print('DS3231 :', Date, Time, end=' ')
        Control = ds.ReadControl()
        #print('Control:', Control, end=' ' )
        Status = ds.ReadStatus()
        #print('    Status:', Status, end='    ')
        if Status == 0:
            alarm = 'Alarm     aus'
        if Status == 1:
            alarm = 'Alarm  1  ein'
        if Status == 2:
            alarm = 'Alarm  2  ein'
        if Status == 3:
            alarm = 'Alarm 1+2 ein'
        if Status == 4:
            alarm = 'Alarm Stat 4 '
        if Status == 5:
            alarm = 'Alarm Stat 5 '
        print(alarm, end=' ')
        print(' Control:', Control, end=' ' )
        print('    Status:', Status)
        utime.sleep(1)



""" Messen                                                    """
print('hier ist Programm ', progname)

print('             Set NTP -> RTC')
Date, Time = timing.RTCget()
print('RTC alt    :', Date, Time, rtc.now())
rtcdatetime = timing.RTCsetNTP()
print('RTC NTP    : Set from NTP to UTC', rtcdatetime )
Date, Time = timing.RTCget()
print('RTC UTC    :', Date, Time, rtc.now())

# rtc.init(rtc.now())
print('             time.localtime:    ', utime.localtime())
now = utime.time()
print('             time.time:         ', utime.time())

cet = utime.localtime(now+3600)
rtcdatetime = cet
Date = "{:04d}-{:02d}-{:02d}".format(*rtcdatetime[0:3])
Time = "{:02d}:{:02d}:{:02d}".format(*rtcdatetime[3:6])
print('RTC CET    :', Date, Time, cet)

Date, Time = timing.GetCEST()
print('RTC CEST   :', Date, Time)
year, month, day, hour, minute, second, ms, dayinyear = timing.GetTime()
print('             GetTime             ',year, month, day, hour, minute, second, ms, dayinyear)


print(' ')
print('             Set RTC -> DS3231')
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 alt :', Date, Time, alarm, alarmstatus)
YYYY, MM, DD, hh, mm, ss = timing.DS3231setCEST()
print('DS3231     : from RTC to CEST                  ', YYYY, MM, DD, hh, mm, ss )
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231 neu :', Date, Time, alarm, alarmstatus)

dd, hh, mm, ss, type, enabled, triggerd = alarmstatus
print('Status     : day:', dd, 'hour:', hh, 'min:', mm, 'sec:', ss, 'type:', type, 'enabled:', enabled, 'triggerd:', triggerd)

print(' ')
print('Test RTC     ')
now = utime.time()
print('RTC UTC    :', now)
timeRTC = now + 3600
print('RTC CEST   :', timeRTC)
Date, Time = timing.RTCget()
print('RTC UTC    :', Date, Time, rtc.now())
Date, Time = timing.GetCEST()
print('RTC CEST   :', Date, Time)

#print('')
#print('Test DS3231')
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
print('DS3231     :', Date, Time, alarm, alarmstatus)

(year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
# print('hour', hour)
timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
print('DS3231 sec :', timeDS3231)
timedif = timeDS3231 - timeRTC
print('Diff   sec :', timedif)





#
