# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.3.2021
progname = "tj1-log"
host     = 'WiPy2'

"""    import                                                 """
import machine
from   machine import Pin, I2C, RTC, ADC
import binascii

import   utime
rtc    = machine.RTC()
import   sensors.timing
timing = sensors.timing.TIMING()
i2c    = I2C(0, I2C.MASTER, pins=('P9', 'P10'))
ds     = sensors.ds3231.DS3231(i2c)

from lib.config import Config

import logger
csv  = logger.csv
beep = logger.beep

import network
import uos

from lib.wlanmanager import WLanManager
config  = Config.getInstance()
wlanman = WLanManager(config)
wlan    = network.WLAN(id=0)

import sensors.bme280
import sensors.hx711
from   lib.onewire     import OneWire
from   sensors.ds18x20 import DS18X20
import sensors.ssd1306

adc = ADC(0)

""" defines                                                    """
volt              = 4.2
IntervalAlarmAus  =  30           # aus   sec  1. Test 1 Messung pro 1 Minute

def DS3231Show():
    Date = "{:04d}-{:02d}-{:02d}".format(*ds.getDate())
    Time = "{:02d}:{:02d}:{:02d}".format(*ds.getTime())
    print( Date, Time, end=' ')
    Status = ds.ReadStatus()
    if Status == 0:
        print(' Alarm     aus', end=' ')
    if Status == 1:
        print(' Alarm  1  ein', end=' ')
    if Status == 2:
        print(' Alarm  2  ein', end=' ')
    if Status == 3:
        print(' Alarm 1+2 ein', end=' ')
    if Status == 4:
        print(' Alarm BSY aus', end=' ')
    if Status == 5:
        print(' Alarm BSY ein', end=' ')

""" init                                                       """
print('this is program: ', progname)

print("WLan       : is enabled, trying to connect.")
wlanman.enable_client()
IPadr, Netmask, Gateway, DNS = wlan.ifconfig()
print('Wlan IP-Adr:', IPadr)
print('Wlan SSID  :', wlan.ssid())
wlan.hostname(host)
print('Wlan host  :', wlan.hostname())

print('             Set NTP -> RTC')
Date, Time = timing.RTCget()
print('RTC alt    :', Date, Time, rtc.now())
rtcdatetime = timing.RTCsetNTP()
print('RTC NTP    : Set from NTP to UTC', rtcdatetime )
Date, Time = timing.RTCget()
print('RTC UTC    :', Date, Time, rtc.now())
Date, Time = timing.GetCEST()
print('RTC CEST   :', Date, Time)

if config.get_value('general','general', 'oled'):
    try:
        i2c = I2C(0, I2C.MASTER, pins=(
            config.get_value('sensors','bme280', 'pin_sda'),
            config.get_value('sensors','bme280', 'pin_scl')))
        oled = sensors.ssd1306.SSD1306_I2C(128, 64, i2c)    # OLED x, y, bus
        oled.contrast(250)
        print("OLED       : initialization OK. ")
    except:
        oled = None
        print("OLED : initialization failed. Is it connected properly?")
else:
    oled = None

""" Compare RTC and DS3231 """
# RTC
Date, Time = timing.GetCEST()
print('RTC CEST   :', Date, Time, end=' ')
now = utime.time()
timeRTC = now + 3600
print(' sec :', timeRTC)
# DS3231
Date, Time, alarm, alarmstatus = timing.DS3231getfull()
# print('DS3231     :', Date, Time, alarm, alarmstatus)
(year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
print('DS3231     :', Date, Time, ' sec :', timeDS3231,  alarm, alarmstatus)
#print('DS3231 sec :', timeDS3231)
timedif = timeDS3231 - timeRTC
print('Diff   sec :', timedif)

print('')
""" Messen                                                     """
countanf =   1
countmax =  99999 #10
for count in range(countanf, countmax+1):
    print("{:3d}/{:3d} ".format(count, countmax), end='  ')
    data = {}

    """ Status von DS3231 """
    # DS3231Show()
    Date, Time, alarm, alarmstatus = timing.DS3231getfull()
    print('DS3231 akt :', Date, Time, alarm, alarmstatus)

    """ Messen """
    """  Read data from BME280  """
#    print('          Messen von BMD280')
#    utime.sleep(1)

    """ Read data from HX711 Gewicht """
#    print('          Messen von HX711')
#    utime.sleep(1)

    """ Read data from DS18B20 Temperaturen """
#    print('          Messen von DS18B20')
#    utime.sleep(1)

    """ Read data from ADC  Voltage  """
    adw = adc.channel(pin='P16',attn=ADC.ATTN_11DB)  #  max. 3.7 V
    wert = adw()
    print('          VBATT    : Value:', wert, end=' ')
    # Wert des ADW
    vist  = config.get_value('general','general', 'vist')
    # Sollausgabe in mV
    vsoll = config.get_value('general','general', 'vsoll')
    volt = wert * (vsoll / vist)
    volt = round(volt/1000,2)
    print('   Volt:', volt, 'V' )
    data['bv'] = volt

    """ Ausgaben """

    """ Ausgabe auf OLED """
    if oled is not None:
        try:
            print('          OLED     : Ausgabe')
#            oled.fill(0)                                       # alles aus
#            oled.text(str(count),                   0,  0)
#            oled.text(Time,                        64,  0)
#            oled.show()
        except:
            print('OLED defect',end=' ')

    """ Alarm neu berechnen """
    if count == 99999: #20:

        """ Compare RTC and DS3231 """
        # RTC
        Date, Time = timing.GetCEST()
        print('RTC CEST   :', Date, Time, end=' ')
        now = utime.time()
        timeRTC = now + 3600
        print(' sec :', timeRTC)
        TimeRTC = Time
        # DS3231
        Date, Time, alarm, alarmstatus = timing.DS3231getfull()
        (year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
        timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
        print('DS3231     :', Date, Time, ' sec :', timeDS3231,  alarm, alarmstatus)
        timedif = timeDS3231 - timeRTC
        print('Diff   sec :', timedif)
        TimeDS3231 = Time

        """  Bestimmen der Schaltzeiten  """
        if volt < 4.0: IntervalAlarmAus =   60   # + 30 sec =  1 min     60 / Stunde
        if volt < 3.8: IntervalAlarmAus =   90   # + 30 sec =  2 min     30 / Stunde
        if volt < 3.6: IntervalAlarmAus =  270   # + 30 sec =  5 min     12 / Stunde
        if volt < 3.4: IntervalAlarmAus =  570   # + 30 sec = 10 min      6 / Stunde
        if volt < 3.2: IntervalAlarmAus = 1770   # + 30 sec = 30 min      2 / Stunde
        if volt < 3.0: IntervalAlarmAus = 3570   # + 30 sec = 60 min      1 / Stunde
        #IntervalAlarmAus =   10
        print('Spannung   : volt:', volt, '-> IntervalAlarmAus:', IntervalAlarmAus)
#       IntervalAlarmAus = IntervalAlarmAus + 1

        """ Alarm neu berechnen """
        # Status akt. Zeit von DS3231
        (year, month,  day)                     = ds.getDate()
        (hour, minute, second)                  = ds.getTime()
        timeakt = utime.mktime([year,month,day,hour,minute,second, 0, 0])
        timealarm = timeakt + IntervalAlarmAus
#        print('timeakt:', timeakt, 'timealarm:', timealarm, end='')
        (year, month,  day, hour, minute, second, x1, x2) =  utime.gmtime(timealarm)
        Date =  "{:4d}-{:02d}-{:02d}".format(year, month,  day)
        Time = "{:02d}:{:02d}:{:02d}".format(hour, minute, second)
        print('             ', end='')
        print('Alarm neu  in', IntervalAlarmAus, 'sec um', Date, Time)
        ds.setAlarm1(day, hour, minute, second, sensors.ds3231.A1_ON_HOUR_MINUTE_SECOND)
        ds.enableAlarm1()

        Date, Time, alarm, alarmstatus = timing.DS3231getfull()
        (year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
        timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
        print('DS3231 2.  :', Date, Time, ' sec :', timeDS3231,  alarm, alarmstatus)

    #    utime.sleep(2)
        """ Testausgabe auf OLED """
        oled.fill(0)                                       # alles aus
        oled.text(str(count),                   0,   0)
        oled.text(Time,                        64,   0)

        oled.text('RTC',                        0,   9)
        oled.text(TimeRTC,                     64,   9)

        oled.text('DS3231',                     0,  18)
        oled.text(TimeDS3231,                  64,  18)

        oled.text('Differenz',                  0,  27)
        oled.text(str(timedif),               110,  27)

        oled.text("Spannung",                   0,  36)
        oled.text(str(volt),                   85,  36)
        oled.text("V",                        118,  36)
#        oled.text("               x"   ,         0, 45)
#        oled.text("DS3231"             ,         0, 45)
#        oled.text( Time ,                       60, 45)
        oled.text("Interval"            ,         0, 54)
        oled.text(str(IntervalAlarmAus),        100, 54)
        oled.show()
        utime.sleep(2)

        """ Alarm ausschalten """
        print('Alarm      : ausschalten')
# 1.    ds.resetAlarm1()
        Date, Time, alarm, alarmstatus = timing.DS3231getfull()
        (year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
        timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
        print('DS3231 3.  :', Date, Time, ' sec :', timeDS3231,  alarm, alarmstatus)
# 2.
        YYYY, MM, DD, hh, mm, ss = timing.DS3231setCEST()
        print('DS3231     : from RTC to CEST                  ', YYYY, MM, DD, hh, mm, ss )
        # print('DS3231 neu :', Date, Time, alarm, alarmstatus)
        # dd, hh, mm, ss, type, enabled, triggerd = alarmstatus
        # print('Status     : day:', dd, 'hour:', hh, 'min:', mm, 'sec:', ss, 'type:', type, 'enabled:', enabled, 'triggerd:', triggerd)

        """ Compare RTC and DS3231 """
        # RTC
        Date, Time = timing.GetCEST()
        print('RTC CEST   :', Date, Time, end=' ')
        now = utime.time()
        timeRTC = now + 3600
        print(' sec :', timeRTC)
        # DS3231
        Date, Time, alarm, alarmstatus = timing.DS3231getfull()
        (year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
        timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
        print('DS3231     :', Date, Time, ' sec :', timeDS3231,  alarm, alarmstatus)
        timedif = timeDS3231 - timeRTC
        print('Diff   sec :', timedif)

        #count = count
        timesleep = IntervalAlarmAus
        Date, Time = timing.GetCEST()
        print('end of count', count, ': deepsleep', timesleep, 'sec at', Date, Time)
        # utime.sleep(timesleep)
        machine.deepsleep(timesleep*1000)

    """ normale Schleife """

    """ Compare RTC and DS3231 """
    # RTC
    Date, Time = timing.GetCEST()
    print('RTC CEST   :', Date, Time, end=' ')
    now = utime.time()
    timeRTC = now + 3600
    print(' sec :', timeRTC)
    TimeRTC = Time
    # DS3231
    Date, Time, alarm, alarmstatus = timing.DS3231getfull()
    (year, month, day, dayofweek, hour, minute, second) = ds.getDateTime()
    timeDS3231 = utime.mktime([year,month,day,hour,minute,second, 0, 0])
    print('DS3231     :', Date, Time, ' sec :', timeDS3231,  alarm, alarmstatus)
    timedif = timeDS3231 - timeRTC
    print('Diff   sec :', timedif)
    TimeDS3231 = Time

    """ Testausgabe auf OLED """
    oled.fill(0)                                       # alles aus
    oled.text(str(count),                   0,   0)
    oled.text(Time,                        64,   0)

    oled.text('RTC',                        0,   9)
    oled.text(TimeRTC,                     64,   9)

    oled.text('DS3231',                     0,  18)
    oled.text(TimeDS3231,                  64,  18)

    oled.text('Differenz',                  0,  27)
    oled.text(str(timedif),               80,  27)

    oled.text("Spannung",                   0,  36)
    oled.text(str(volt),                   85,  36)
    oled.text("V",                        118,  36)
    oled.text("Interval"            ,        0, 45)
    oled.text(str(IntervalAlarmAus),       100, 45)
    oled.text('warten ',                     0, 54)
    wait = 10
    oled.text(str(wait),                    75, 54)
    oled.text('sec',                       100, 54)
    oled.show()


    print('warten ...', wait, ' sec')
    utime.sleep(wait)
