# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.3.2021
progname = "tj2-time"
host     = 'WiPy2'

"""    import                                                 """
import machine
from   machine import Pin, I2C, RTC, ADC
import binascii
import sys

import   time
rtc    = machine.RTC()
import   sensors.timing
timing = sensors.timing.TIMING()
i2c    = I2C(0, I2C.MASTER, pins=('P9', 'P10'))
ds     = sensors.ds3231.DS3231(i2c)

from lib.config import Config

import network
import uos

from lib.wlanmanager import WLanManager
config  = Config.getInstance()
wlanman = WLanManager(config)
wlan    = network.WLAN(id=0)


""" defines                                                    """
volt              = 4.2
IntervalAlarmAus  =  30           # aus   sec  1. Test 1 Messung pro 1 Minute

""" init                                                       """
print('This is program: ', progname)

print("WLan       : is enabled, trying to connect.")
wlanman.enable_client()
IPadr, Netmask, Gateway, DNS = wlan.ifconfig()
wlan.hostname(host)
print('Wlan host  :', wlan.hostname(), end=' ')
print(' SSID :', wlan.ssid(), end=' ')
print(' IP-Adr:', IPadr)

#print(' ')
print('             Set NTP -> RTC')
Date, Time = timing.RTCget()
print('RTC alt    :', Date, Time )
Date, Time, Epoch = timing.RTCgetFull()
print('RTC alt    :', Date, Time, 'Epoch:', Epoch )

print('RTC NTP    : Set from NTP to UTC' )
rtcdatetime = timing.RTCsetNTP()
# Date, Time = timing.RTCget()
# print('RTC UTC    :', Date, Time, rtc.now())
Date, Time, Epoch = timing.RTCgetFull()
print('RTC UTC    :', Date, Time, 'Epoch:', Epoch )
# print('RTC NTP    : Set from NTP to CEST' )
# rtcdatetime = timing.RTCsetCEST()
# Date, Time, Epoch = timing.RTCgetFull()
# print('RTC CEST   :', Date, Time, 'Epoch:', Epoch )
Date, Time, Epoch = timing.RTCgetCEST()
print('RTC CEST   :', Date, Time, 'Epoch:', Epoch)
timeRTC = Epoch
year, month, day, hour, minute, second, ms, dayinyear = timing.RTCgetAll()
print('RTC CEST   :', year, month, day, hour, minute, second, ms, dayinyear)

Date, Time = timing.DS3231get()
print('DS3231     :', Date, Time )
Date, Time, Epoch = timing.DS3231getFull()
print('DS3231     :', Date, Time, 'Epoch:', Epoch )
timeDS3231 = Epoch
""" Compare RTC and DS3231 """
timedif = timeDS3231 - timeRTC
print('Differenz  : DS3231 - RTC        in sec      ', timedif)

year, month, day, hour, minute, second = timing.DS3231getAll()
print('DS3231     :', year, month, day, hour, minute, second )

Date, Time, alarm, alarmstatus, TimeA1, ein = timing.DS3231getAlarm1()
print('DS3231     :', Date, Time, alarm, 'um', TimeA1, 'Ein:', ein, alarmstatus )

# datetime = timing.DS3231setRTC()
# print('DS3231 set :', datetime)
YYYY, MM, DD, hh, mm, ss = timing.DS3231setCEST()
print('DS3231 set :', YYYY, MM, DD, hh, mm, ss )
Date, Time, alarm, alarmstatus, TimeA1, ein = timing.DS3231getAlarm1()
print('DS3231     :', Date, Time, alarm, 'um', TimeA1, 'Ein:', ein, alarmstatus )

interval = 5
Date, Time = timing.DS3231setAlarm1(interval)
print('DS3231 alm :', Date, Time, 'Alarm  1  ein' )
Date, Time, alarm, alarmstatus, TimeA1, ein = timing.DS3231getAlarm1()
print('DS3231     :', Date, Time, alarm, 'um', TimeA1, 'Ein:', ein, alarmstatus )

wait = interval
print('warten ...  ', wait, ' sec')
time.sleep(wait)
Date, Time, alarm, alarmstatus, TimeA1, ein = timing.DS3231getAlarm1()
print('DS3231     :', Date, Time, alarm, 'um', TimeA1, 'Ein:', ein, alarmstatus )



### sys.exit('Ende')

print('')
""" Messen   #############################################################   """
countanf =   1
countmax =  2# 99999 #10
for count in range(countanf, countmax+1):
    print("{:3d}/{:3d} ".format(count, countmax), end=' ')

    """ Differenz RTC DS3231  """
    Date, Time, Epoch = timing.RTCgetCEST()
    print('RTC CEST   :', Date, Time, 'Epoch:', Epoch)
    timeRTC = Epoch
    Date, Time, Epoch = timing.DS3231getFull()
    print('         ', end='')
    print('DS3231     :', Date, Time, 'Epoch:', Epoch )
    timeDS3231 = Epoch
    timedif = timeDS3231 - timeRTC
    print('         ', end='')
    print('Differenz  : DS3231 - RTC        in sec      ', timedif)

    """ Messen """
    wait = 10
    print('Messen ...  ', wait, ' sec')
    time.sleep(wait)

    """ Alarm 1 setzen """
    interval = 5
    Date, Time = timing.DS3231setAlarm1(interval)
    print('DS3231 alm :', Date, Time, 'Alarm  1  ein' )
    Date, Time, alarm, alarmstatus, TimeA1, ein = timing.DS3231getAlarm1()
    print('DS3231     :', Date, Time, alarm, 'um', TimeA1, 'Ein:', ein, alarmstatus )

    wait = 5
    # print('         ', end='')
    print('warten ...  ', wait, ' sec')
    time.sleep(wait)

    Date, Time, alarm, alarmstatus, TimeA1, ein = timing.DS3231getAlarm1()
    print('DS3231     :', Date, Time, alarm, 'um', TimeA1, 'Ein:', ein, alarmstatus )
