# Testprogramm Board BOB-HAT-V6                      Didi Lamken 6.3.2021
progname = "tj5-time"
host     = 'WiPy2'

"""    import                                                                """
import machine
from   machine import Pin, I2C, RTC, ADC
import binascii
import sys

import   time
rtc    = machine.RTC()
import   sensors.timing
timing = sensors.timing.TIMING()
i2c    = I2C(0, I2C.MASTER, pins=('P9', 'P10'))
ds     = sensors.ds3231.DS3231(i2c)

from lib.config import Config

import logger
csv  = logger.csv
beep = logger.beep

import network
import uos

from lib.wlanmanager import WLanManager
config  = Config.getInstance()
wlanman = WLanManager(config)
wlan    = network.WLAN(id=0)

import sensors.bme280
import sensors.hx711
from   lib.onewire     import OneWire
from   sensors.ds18x20 import DS18X20
import sensors.ssd1306
adc = ADC(0)

""" defines                                                                  """
volt              = 4.2
IntervalAlarmAus  =  30           # aus   sec  1. Test 1 Messung pro 1 Minute

""" init                                                                     """
print('This is program: ', progname)
# network
print("WLan       : is enabled, trying to connect")
wlanman.enable_client()
IPadr, Netmask, Gateway, DNS = wlan.ifconfig()
wlan.hostname(host)
print('Wlan host  :', wlan.hostname(), end=' ')
print(' SSID :', wlan.ssid(), end=' ')
print(' IP-Adr:', IPadr)
# RTC
print('             Set NTP -> RTC')
Date, Time, Epoch = timing.RTCgetFull()
print('RTC alt    :', Date, Time, 'Epoch:', Epoch )
print('RTC NTP    : Set from NTP to UTC' )
rtcdatetime = timing.RTCsetNTP()
Date, Time, Epoch = timing.RTCgetFull()
print('RTC UTC    :', Date, Time, 'Epoch:', Epoch )
Date, Time, Epoch = timing.RTCgetCEST()
print('RTC CEST   :', Date, Time, 'Epoch:', Epoch)
timeRTC = Epoch
# DS3231
Date, Time, Epoch = timing.DS3231getFull()
print('DS3231     :', Date, Time, 'Epoch:', Epoch )
timeDS3231 = Epoch
""" Compare RTC and DS3231 """
timedif = timeDS3231 - timeRTC
print('Differenz  : DS3231 - RTC        in sec      ', timedif)
Date, Time, alarm, alarmstatus, TimeA1, ein = timing.DS3231getAlarm1()
print('DS3231     :', Date, Time, alarm, 'um', TimeA1, 'Ein:', ein, alarmstatus )

if config.get_value('general','general', 'oled'):
    try:
        i2c = I2C(0, I2C.MASTER, pins=(
            config.get_value('sensors','bme280', 'pin_sda'),
            config.get_value('sensors','bme280', 'pin_scl')))
        oled = sensors.ssd1306.SSD1306_I2C(128, 64, i2c)    # OLED x, y, bus
        oled.contrast(250)
        print("OLED       : initialization OK. ")
    except:
        oled = None
        print("OLED : initialization failed. Is it connected properly?")
else:
    oled = None


print('')
""" Messen   #############################################################   """
countanf =   1
countmax =   2  # 99999
for count in range(countanf, countmax+1):
    print("{:3d}/{:3d} ".format(count, countmax), end=' ')
    data = {}

    """ Differenz RTC DS3231  """
    Date, Time, Epoch = timing.RTCgetCEST()
    print('RTC CEST   :', Date, Time, 'Epoch:', Epoch)
    RTCTime = Time
    timeRTC = Epoch
    Date, Time, Epoch = timing.DS3231getFull()
    print('         ', end='')
    print('DS3231     :', Date, Time, 'Epoch:', Epoch )
    DS3231Time = Time
    timeDS3231 = Epoch
    timedif = timeDS3231 - timeRTC
    print('         ', end='')
    print('Differenz  : DS3231 - RTC        in sec      ', timedif)

    """ Messen """
    wait = 1
    print('         ', end='')
    print('Messen ...  ', wait, ' sec')
    time.sleep(wait)

    """  Read data from BME280  """
#    print('          Messen von BMD280')
#    utime.sleep(1)

    """ Read data from HX711 Gewicht """
#    print('          Messen von HX711')
#    utime.sleep(1)

    """ Read data from DS18B20 Temperatures """

    """ Read data from ADC  Voltage  """
    adw = adc.channel(pin='P16',attn=ADC.ATTN_11DB)  #  max. 3.7 V
    wert = adw()
    print('         VBATT      : Value:', wert, end=' ')
    # Wert des ADW
    vist  = config.get_value('general','general', 'vist')
    # Sollausgabe in mV
    vsoll = config.get_value('general','general', 'vsoll')
    volt = wert * (vsoll / vist)
    volt = round(volt/1000,2)
    print(' Volt:', volt, 'V', end=' ' )
    data['bv'] = volt

    
    """  Bestimmen der Schaltzeiten  """
    if volt < 4.0: IntervalAlarmAus =   30   # + 30 sec =  1 min     60 / Stunde
    if volt < 3.8: IntervalAlarmAus =   90   # + 30 sec =  2 min     30 / Stunde
    if volt < 3.6: IntervalAlarmAus =  270   # + 30 sec =  5 min     12 / Stunde
    if volt < 3.4: IntervalAlarmAus =  570   # + 30 sec = 10 min      6 / Stunde
    if volt < 3.2: IntervalAlarmAus = 1770   # + 30 sec = 30 min      2 / Stunde
    if volt < 3.0: IntervalAlarmAus = 3570   # + 30 sec = 60 min      1 / Stunde
    #IntervalAlarmAus =   10
    print('-> IntervalAlarmAus:', IntervalAlarmAus)




    """ output auf OLED """
    if oled is not None:
        try:
            print('         OLED       : output')
            oled.fill(0)                                       # alles aus
            oled.text(str(count),         0,   0)
            oled.text(RTCTime,           64,   0)
            oled.text('DS3231',           0,  10)
            oled.text(DS3231Time,        64,  10)
            oled.text('Diff',             0,  20)
            oled.text(str(timedif),      64,  20)
            oled.text("Spannung",         0,  30)
            oled.text(str(volt),         85,  30)
            oled.text("V",              118,  30)
            oled.text("Interval"           ,   0, 40)
            oled.text(str(IntervalAlarmAus), 100, 40)

            oled.show()
        except:
            print('OLED defect',end=' ')



    """ Alarm with deepsleep """
    if count == 2:
        print('             Alarm with deepsleep')
        """ Alarm 1 set """
        #interval = IntervalAlarmAus
        time.sleep(2)

        Date, Time = timing.DS3231setAlarm1(IntervalAlarmAus)
        print('DS3231 alm :', Date, Time, 'Alarm  1  ein' )
        Date, Time, alarm, alarmstatus, TimeA1, ein = timing.DS3231getAlarm1()
        print('DS3231     :', Date, Time, alarm, 'um', TimeA1, 'Ein:', ein, alarmstatus )

        # end with deepsleep
        #wait = interval
        # print('         ', end='')
        print('deepsleep  :', IntervalAlarmAus, ' sec')
        machine.deepsleep(IntervalAlarmAus*1000)
